{ Predmet : Strukture i Baze podataka                            }
{ Programski jezik : Borland Turbo Pascal 7.0                    }
{ Autor: Bajramovic Kemal                                        }
{                                                                }
{ 1 zadatak :   Data je struktura opisana sa:                    }
{               type pokazivac =^slog;                           }
{                    pokazivac1=^slog1;                          }
{                    slog = record                               }
{                           pisac:string[25];                    }
{                           slijedeci:pokazivac;                 }
{                           dijela:pokazivac1;                   }
{                    slog1= record                               }
{                           naslov:string[25];                   }
{                           godina:integer;                      }
{                           grad:string[25];                     }
{                           slijedeci:pokazivac1                 }
{                           end;                                 }
{                                                                }
{Kreirati listu ,automatsko sortiranje po poljima pisac i naslov }
{odstampati strukturu.                                           }


program pisac (input,output);
uses crt;
type pokazivac=^slog;
     pokazivac1=^slog1;
     slog = record
            pisac:string;
            slijedeci:pokazivac;
            djela:pokazivac1
            end;
     slog1= record
            naslov:string;
            godina:integer;
            grad:string;
            slijedeci:pokazivac1
            end;
var glava,izapisca,ispredpisca,nadjenipisac:pokazivac;
    izadjela,ispreddjela,nadjenodjelo:pokazivac1;
    imepisca,nazivdjela,grad:string;
    godina:integer;
    izbor:char;

procedure pripremi (var iza,ispred:pokazivac; x:string);
          begin
          iza:=glava;
          begin
{Dok je prvo slovo imena novog pisca vece od aktualnog pisca i }
{dok nije zadnji pisac ,pisac iza postaje ispred,a             }
{iza.^slijedeci postaje iza.                                   }
          while (ord(x[1]) > ord(iza^.pisac[1])) and (iza <> NIL) do
                begin
                ispred:=iza;
                iza:=iza^.slijedeci
                end;
          end;
        end;
procedure UbaciPisca;
          var novi:pokazivac;
          begin
          writeln ('Unesi prezime i ime pisca:');
          readln (imepisca);
{Korisnik je odlucio da unese novog pisca u strukturu.Nakon unosa}
{njegovog imena poziva se procedura Pripremi koja ce pokazivace  }
{izapisca i ispredpisca napuniti vrijednostima adresa na kojima  }
{su imena pisaca cija su prva slova u imenu po ORDinalnoj        }
{vrijednosti manja odnosno veca od prvog slova u imenu           }
{pisca kojeg upisujemo.Na taj nacin postizemo automatsko         }
{sortiranje po polju pisac.                                      }
          pripremi (izapisca,ispredpisca,imepisca);
          new (novi);
{Slijedi upis elemenata sloga u novodeklarisani memorijski       }
{prostor.                                                        }
          novi^.pisac:=imepisca;
          novi^.djela:=NIL;
          novi^.slijedeci:=izapisca;
{Upis novog pisca na celo liste pisaca.                          }
          if izapisca=glava then
          glava:=novi  else
          ispredpisca^.slijedeci:=novi;
          end;

procedure nadjipisca (var pok:pokazivac;ime:string);
{Procedura nadjipisca radi na sljedeci nacin:Pokazivac pok      }
{pokazuje na prvi element liste pisaca,zavrtimo petlju:dok je   }
{polje pisac aktualnog sloga pisac} {razlicit od varijable ime  }
{koju je procedura dobila iz procedure UbaciPisca i dok nije    }
{kraj liste slogova pisac uzmi sledeci slog pisac za aktualni   }
{slog.                                                          }
          begin
          pok:=glava;
          while (pok^.pisac <> ime) and (pok <> NIL) do
                begin
                pok:=pok^.slijedeci
                end;
          end;

procedure pripremidjelo (var iza,ispred:pokazivac1;nadjenipisac:pokazivac;x:string);

          begin
          iza := nadjenipisac^.djela;
{Dok je prvo slovo imena novog djela vece od aktualnog djela i }
{dok nije zadnje djelo ,djelo iza postaje ispred,a             }
{iza.^slijedeci postaje iza.                                   }
          while (ord(x[1]) > ord(iza^.naslov[1])) and (iza <> NIL) do
                begin
                ispred := iza;
                iza:=iza^.slijedeci
                end;
          end;

procedure punidjelo (ispred,iza:pokazivac1;pisac:pokazivac;naslov,grad:string;godina:integer);
          var novi:pokazivac1;
{Slijedi upis elemenata sloga u novodeklarisani memorijski     }
{prostor.                                                      }

          begin
          new (novi);
          novi^.naslov:=naslov;
          novi^.godina:=godina;
          novi^.grad:=grad;
          novi^.slijedeci:=iza;
{Upis novog djela na celo liste djela.                         }
          if iza=pisac^.djela then
          pisac^.djela:=novi  else
          ispred^.slijedeci:=novi;
          end;

procedure UbaciDjelo;
          begin
          writeln ('Unesi prezime i ime pisca kojem zelis dodati djelo:');
          readln(imepisca);
{Na ovom mjestu je potrebno provjeriti da li pisac kojem zelimo  }
{pridruziti neko djelo uopste postoji u strukturi.U tu svrhu     }
{koristimo proceduru nadjipisca.Ako procedura vrati pokazivac    }
{nadjipisca sa vrijednoscu NIL to znaci da pisac tog imena u     }
{strukturi ne postoji,program prekida postupak unosa novog dijela}
{sa preporukom korisniku da je potrebno prvo kreirati pisca u    }
{strukturi.Ako je pokazivac nadjenipisac razlicit od NIL to znaci}
{da taj pisac postoji a ovaj pokazivac upravo ukazuje na njega.  }
{Dalje slijedi upis slogova za novo djelo.                       }
          nadjipisca(nadjenipisac,imepisca);
          if nadjenipisac <> NIL then
             begin
             writeln ('Unesi naziv djela:');
             readln(nazivdjela);
             {$I-}
             repeat
{Ova repeat petlja onemogucava gresku prilikom unosa godine    }
{izdavanja dijela.Ako unesemo nenumericku vrijednost,funkcija  }
{IOResult vraca vrijednost razlicitu od 0. Kada unesemo        }
{numericku vrijednost funkcija IOResult jednaka je 0,petlja    }
{propusta i program se moze nastaviti.Da bi funkcija IOResult  }
{radila potrebno je izdati direktivu prevodiocu da iskluci     }
{opciju I/O Cheking.                                           }
             writeln ('Unesi godinu izdavanja,ali numericki:');
             readln(godina)
             until IOResult=0;
             {$I+}
             writeln ('Unesi mjesto izdavanja:');
             readln(grad);
             pripremidjelo(izadjela,ispreddjela,nadjenipisac,nazivdjela);
{Analogno proceduri pripremi koja radi za pisca ova procedura }
{priprema dijelo.Potrebno je napuniti pokazivace izadjela i   }
{ispreddjela vrijednostima memorijskih lokacija dijela koja   }
{imaju prvo slovo u imenu po ORDinalnoj vrijednosti manje     }
{odnosno vece u odnosu na djelo koje upisujemo.Na ovaj nacin  }
{postizemo sortiranost slogova djela po polju naslov.         }
             punidjelo(ispreddjela,izadjela,nadjenipisac,nazivdjela,grad,godina)
{U ovoj proceduri punimo polja sloga novog djela.             }
             end
             else
             begin
             writeln('Pisac tog prezimena i imena ne postoji u strukturi!');
             writeln('Preporuka: Prvo unesite pisca u strukturu.');
{Funkcija KeyPressed omogucava nam da vidimo gornju poruku    }
{upozorenja,da ovu funkciju nismo koristili korisnik ne bi    }
{uspio vidjeti poruku o gresci vec bi mu program ponudio      }
{pocetni meni.                                                }
             while KeyPressed = False do
             begin
             end
             end;
          end;

procedure pripremidjelobrisanje (var ispred,nadjenodjelo:pokazivac1;nadjenipisac:pokazivac;naslovdjela:string);
          begin
{Procedura pronalazi vrijednosti pokazivaca na djelo koje brisemo}
{te na djelo koje je ispred njega,ako djelo ne postoji pokazivaci}
{imaju vrijednosti NIL.                                          }
          nadjenodjelo:=nadjenipisac^.djela;
          while (nadjenodjelo^.naslov <> naslovdjela) and (nadjenodjelo <> NIL) do
                begin
                ispred:=nadjenodjelo;
                nadjenodjelo:=nadjenodjelo^.slijedeci
                end;
          end;

procedure brisi(ispred,nadjenodjelo:pokazivac1;nadjenipisac:pokazivac);
          begin
{Ako je nadjenodjelo koje brisemo na celu liste slogova djela }
{tada nam ne treba  vrijednost pokazivaca ispred.             }
          if nadjenodjelo=nadjenipisac^.djela then
             begin
             nadjenipisac^.djela:=NIL;
             dispose(nadjenodjelo)
             end
          else
             begin
             ispred^.slijedeci:=nadjenodjelo^.slijedeci;
             dispose(nadjenodjelo)
             end;
          end;

procedure BrisanjeDjela;
          begin
          writeln('Unesi prezime i ime pisca cije djelo brisete:');
          readln(imepisca);
          nadjipisca(nadjenipisac,imepisca);
{Na ovom mjestu je potrebno provjeriti da li pisac kojem zelimo}
{obrisati neko djelo uopste postoji u strukturi.U tu svrhu     }
{koristimo proceduru nadjipisca.Ako procedura vrati pokazivac  }
{nadjipisca sa vrijednoscu NIL to znaci da pisac tog imena u   }
{strukturi ne postoji,program prekida postupak brisanja dijela }
{sa porukom korisniku da pisca tog imena nema u strukturi.Ako  }
{je pokazivac nadjenipisac razlicit od NIL to znaci da taj     }
{pisac postoji a ovaj pokazivac upravo ukazuje na njega.Dalje  }
{slijedi postupak brisanja djela.                              }
           if nadjenipisac <> NIL then
                 begin
                 writeln('Unesi naziv djela:');
                 readln(nazivdjela);
                 pripremidjelobrisanje(ispreddjela,nadjenodjelo,nadjenipisac,nazivdjela);
{Ako smo utvrdili da postoji pisac cije dijelo brisemo sada treba}
{na isti nacin utvrditi da li postoji i to dijelo koje brisemo.  }
{Ako postoji poziva se procedura brisi koja ce djelo obrisati a  }
{ako ne postoji odgovarajuca poruka o gresci se salje korisniku. }
                      if nadjenodjelo <> NIL then
                      begin
                      brisi(ispreddjela,nadjenodjelo,nadjenipisac)
                      end
                      else
                      writeln('Navedeno djelo ne postoji u strukturi te operacija brisanja ne moze biti izvedena!');
                      while KeyPressed = False do
             begin
             end

                 end
                 else
                 writeln('Ne postoji pisac tog imena u strukturi,s toga je operacija brisanja neizvodiva!');
                 while KeyPressed = False do
             begin
             end
               end;

procedure nadjiprethodni (ispredpisca,nadjenipisac:pokazivac;imepisca:string);
          begin
          ispredpisca := glava;
          while ispredpisca^.slijedeci <> nadjenipisac do
                ispredpisca:=ispredpisca^.slijedeci;
          end;

procedure prvodjela (nadjenipisac:pokazivac;nadjenodjelo:pokazivac1);
          begin
          while nadjenipisac^.djela <> NIL do
          begin
          nadjenodjelo:=nadjenipisac^.djela;
          nadjenipisac^.djela:=nadjenodjelo^.slijedeci;
          dispose(nadjenodjelo)
          end
          end;

procedure BrisanjePisca;
          var temp:pokazivac;
          begin
{Brisanjem pisca gubimo i sve podatke o njegovim djelima. }
{procedura nadjipisca pronadje pisca,procedura prvodjela  }
{obrise sva djela i na taj nacin uredno oslobodi memoriju }
{i na kraju imamo brisanje samog pisca.                   }
          writeln('Unesite prezime i ime pisca kojeg brisete:');
          writeln('Napomena:brisanjem pisca gubite i sve podatke o njegovim djelima!');
          readln(imepisca);
          nadjipisca(nadjenipisac,imepisca);
          if nadjenipisac <> NIL then
            begin
               if nadjenipisac=glava then
                  begin
                       if nadjenipisac^.djela <> NIL then
                         begin
                           prvodjela(nadjenipisac,nadjenodjelo);
                               glava:=nadjenipisac^.slijedeci;
                               dispose(nadjenipisac)
                          end
                              else
                                    begin
                                 glava:= nadjenipisac^.slijedeci;
                                 dispose(nadjenipisac)
                                    end;
                  end
                       else
                  begin
                       if nadjenipisac^.slijedeci = NIL then
                          begin
                          nadjiprethodni(ispredpisca,nadjenipisac,imepisca);
                          ispredpisca^.slijedeci := NIL;
                             if nadjenipisac^.djela <> NIL then
                                                   begin
                                                 prvodjela(nadjenipisac,nadjenodjelo);
                                                 dispose(nadjenipisac)
                                                    end
                                else
                                begin
                                 dispose(nadjenipisac)
                                end;
                           end
             else
             begin
               if nadjenipisac^.djela <> NIL then
                 begin
                       prvodjela(nadjenipisac,nadjenodjelo);
                       nadjenipisac^.pisac:=nadjenipisac^.slijedeci^.pisac;
                       nadjenipisac^.djela:=nadjenipisac^.slijedeci^.djela;
                       temp:=nadjenipisac^.slijedeci^.slijedeci;
                       dispose (nadjenipisac^.slijedeci);
                       nadjenipisac^.slijedeci:=temp
                 end

               else
               begin
               nadjenipisac^.pisac:=nadjenipisac^.slijedeci^.pisac;
               nadjenipisac^.djela:=nadjenipisac^.slijedeci^.djela;
               temp:=nadjenipisac^.slijedeci^.slijedeci;
               dispose (nadjenipisac^.slijedeci);
               nadjenipisac^.slijedeci:=temp
               end;
             end;
          end;
        end;

               end;
procedure stampajstrukturu;
{Ova procedura stampa strukturu.Prvo se stampa ime pisca a iza }
{njega sva njegova djela.Ukoliko je struktura prazna dobijamo  }
{odgovarajuce obavjestenje.                                    }
          begin
          writeln('Struktura:');
          if glava <> NIL then
             begin
             nadjenipisac:=glava;
             while nadjenipisac <> NIL do
                   begin
                   writeln('-------------------------------');
                   writeln(nadjenipisac^.pisac);
                      if nadjenipisac^.djela <> NIL then
                         begin
                         nadjenodjelo:=nadjenipisac^.djela;
                           while nadjenodjelo <> NIL do
                                 begin
                                 writeln(nadjenodjelo^.naslov,' , ',nadjenodjelo^.godina,' , ',nadjenodjelo^.grad);
                                 nadjenodjelo:=nadjenodjelo^.slijedeci
                                 end;
                                 nadjenipisac:=nadjenipisac^.slijedeci
                         end
                      else
                    nadjenipisac:=nadjenipisac^.slijedeci
                    end;
                     while KeyPressed = False do
             begin
             end;
             end
             else
             begin
             writeln('Struktura je prazna!!!');
             while KeyPressed = False do
             begin
             end;
             end;
          end;


BEGIN
    glava:=NIL;
    repeat
{Nakon provedene opercije nad strukturom program konstantno }
{omogucava korisniku novu operciju nad strukturom sve dok   }
{izbor ne bude opcija 6.                                    }
             repeat
{Ova repeat petlja onemogucava gresku prilikom izbora opcije.}
{Dok korisnik ne unese pravilan izbor opcije , program       }
{konstantno ponavlja ponudu.                                 }
             clrscr;
             writeln('Izaberite opciju: 1. Kreiranje novog pisca,');
             writeln('                  2. Kreiranje novog djela,');
             writeln('                  3. Brisanje djela,');
             writeln('                  4. Brisanje pisca,');
             writeln('                  5. Stampanje strukture,');
             writeln('                  6. Kraj programa.');
             readln(izbor);
             until izbor in ['1','2','3','4','5','6'];
             case izbor of
             '1' : ubacipisca;
             '2' : ubacidjelo;
             '3' : brisanjedjela;
             '4' : brisanjepisca;
             '5' : stampajstrukturu
             end;
   until izbor in ['6'];
   end.
